
/********************************** (C) COPYRIGHT *******************************
* File Name          : UART1.C
* Author             : WCH
* Version            : V1.3
* Date               : 2016/06/24
* Description        : ṩUART1áշ
                       ٶ΢һ㣬ʹ÷׶
*******************************************************************************/
//#include "DEBUG.C"                                                         //Ϣӡ
//#include "DEBUG.H"

#pragma  NOAREGS

UINT8 Uart1Rec_Buf[0x3F];
UINT8 Uart1Rec_Len;                                                          //ռ
UINT8 Uart1SendLen = 0;                                                       //ݷͼ

/*******************************************************************************
* Function Name  : ResetUART1( )
* Description    : CH559UART1˿λ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void ResetUART1( )
{
    SER1_IER |= bIER_RESET;                                                   //λԶգλڼĴ
}

/*******************************************************************************
* Function Name  : CH559UART1Init(UINT8 DIV,UINT8 mode,UINT8 pin)
* Description    : CH559 UART1ʼ
* Input          :
                   UINT8 DIV÷ƵϵʱƵ=Fsys/DIV,DIVΪ0
                   UINT8 modeģʽѡ1ͨģʽ0:485ģʽ
                   UINT8 pinѡ
                   mode=1ʱ
                   0RXD1=P4.0,TXD1رգ
                   1RXD1&TXD1=P4.0&P4.4
                   2RXD1&TXD1=P2.6&P2.7
                   3RXD1&TXD1&TNOW=P2.6&P2.7&P2.5
                   mode=0ʱ
                   0
                   1P5.4&P5.5485,TNOW=P4.4
                   2P5.4&P5.5485
                   3P5.4&P5.5485,TNOW=P2.5
* Output         : None
* Return         : None
*******************************************************************************/
void CH559UART1Init(UINT8 DIV, UINT8 mode, UINT8 pin)
{
    UINT32 x;
    UINT8 x2;

    SER1_LCR |= bLCR_DLAB;                                                    // DLABλ1дDLLDLMDIVĴ
    SER1_DIV = DIV;                                                           // ԤƵ
    x = 10 * FREQ_SYS * 2 / DIV / 16 / BUAD;
    x2 = x % 10;
    x /= 10;

    if ( x2 >= 5 ) x ++;                                                      //

    SER1_DLM = x >> 8;
    SER1_DLL = x & 0xff;
    SER1_LCR &= ~bLCR_DLAB;                                                   //DLABλ0,ֹ޸UART1ʺʱ

    if(mode == 1)                                                             //رRS485ģʽ RS485_EN = 0,ʡ
    {
        XBUS_AUX |=  bALE_CLK_EN;
    }
    else if(mode == 0)                                                        //RS485ģʽ RS485_EN = 1;
    {
        UHUB1_CTRL |= bUH1_DISABLE;
        PIN_FUNC &= ~bXBUS_CS_OE;
        PIN_FUNC |= bXBUS_AL_OE;
        XBUS_AUX &= ~bALE_CLK_EN;
        SER1_MCR |= bMCR_HALF;                                                //485ģʽֻʹð˫ģʽ
    }

    SER1_LCR |= MASK_U1_WORD_SZ;                                              //·
    SER1_LCR &= ~(bLCR_PAR_EN | bLCR_STOP_BIT);                               //·У飬1λֹͣλ8λλ

    SER1_MCR &= ~bMCR_TNOW;
    SER1_IER |= bIER_EN_MODEM_O;
    SER1_IER |= ((pin << 4) & MASK_U1_PIN_MOD);                                //ģʽ
    SER1_IER |= /*bIER_MODEM_CHG | */bIER_LINE_STAT | /*bIER_THR_EMPTY |*/ bIER_RECV_RDY;//жʹ

    SER1_MCR |= bMCR_OUT2;                                                     //MODEMƼĴ
    x2 = SER1_IIR;                                                             //IIRж
    //жʵж
    SER1_ADDR |= 0xff;                                                         //رնͨ
		
		/*жϷʽ*/
    IE_UART1 = 1;                                                              //UART1жʹ
		
		//P4_DIR |= 0x10;                                      //ʹP4ʱһҪ÷,TXD1Ϊ
}

/*******************************************************************************
* Function Name  : CH559UART1RcvByte()
* Description    : CH559UART1һֽ
* Input          : None
* Output         : None
* Return         : ȷUINT8 Rcvdat;
*******************************************************************************/
UINT8  CH559UART1RcvByte( )
{
    while((SER1_LSR & bLSR_DATA_RDY) == 0);                                   //ȴ׼

    return SER1_RBR;
}

/*******************************************************************************
* Function Name  : CH559UART1SendByte(UINT8 SendDat)
* Description    : CH559UART1һֽ
* Input          : UINT8 SendDatҪ͵
* Output         : None
* Return         : None
*******************************************************************************/
void CH559UART1SendByte(UINT8 SendDat)
{
    while ( (SER1_LSR & bLSR_T_ALL_EMP) == 0 );  //ûFIFOȴ1ֽڷ

    SER1_THR = SendDat;
}

/*******************************************************************************
* Function Name  : CH559UART1INTSendStr(PUINT8 SendStr)
* Description    : CH559UART1ͿжϷͶֽ
* Input          : UINT8 SendStr Ҫ͵ݵ׵ַ
* Output         : None
* Return         : None
*******************************************************************************/
void CH559UART1SendStr(PUINT8 SendStr)
{
    PUINT8  temp;
    temp = SendStr;
    while( *temp != '\0' )//
    {
        CH559UART1SendByte(*temp++);
    }
    Uart1SendLen = 0;
}

/*******************************************************************************
* Function Name  : UART1Interrupt(void)
* Description    : UART1жϷ
*******************************************************************************/
void	UART1Interrupt( void ) interrupt INT_NO_UART1 using 1                 //UART1жϷ,ʹüĴ1
{
    UINT8 InterruptStatus, i;
    InterruptStatus = SER1_IIR & 0x0f;                                        //ȡж״̬
	  
    switch(InterruptStatus)
    {
        case U1_INT_RECV_RDY:                                                 //ݿжϣȶȡָֽжϵݸ
            if(SER1_RBR > 0x00)
            {
                Uart1Rec_Buf[Uart1Rec_Len++] = SER1_RBR;                     //FIFOûȡ1ֽ
                Uart1Rec_Len &= 0x3F;
            }
            break;

        case U1_INT_RECV_TOUT:                                                //ճʱж
            if(SER1_RBR > 0x00)
            {
                Uart1Rec_Buf[Uart1Rec_Len] = SER1_RBR;                         //FIFOûȡ1ֽ
            }

            break;

        case U1_INT_LINE_STAT:                                                //·״̬ж
            break;

        case U1_INT_SLV_ADDR:                                                 //豸ַmatchж
            break;

        case U1_INT_NO_INTER:                                                 //ж
            break;

        case U1_INT_MODEM_CHG:                                                //MODEMж
            i = SER1_MSR;
            break;

        case U1_INT_THR_EMPTY:                                                //Ϳжϣ´ηͻߵȴ
            if(Uart1SendLen == 0)//
            {
                SER1_IER &= ~bIER_THR_EMPTY;                                     //ֶʹܷͿжϣԽݷ
            }
            break;

        default:
            break;
    }
}

